# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from humanloop import schemas  # noqa: F401


class EvaluatorConfigResponse(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "name",
            "id",
            "type",
            "evaluator_type",
            "status",
        }
        
        class properties:
            id = schemas.StrSchema
            
            
            class type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
                
                @schemas.classproperty
                def EVALUATOR(cls):
                    return cls("evaluator")
            status = schemas.StrSchema
            name = schemas.StrSchema
            evaluator_type = schemas.StrSchema
            description = schemas.StrSchema
            other = schemas.DictSchema
        
            @staticmethod
            def created_by() -> typing.Type['UserResponse']:
                return UserResponse
        
            @staticmethod
            def model_config() -> typing.Type['ModelConfigResponse']:
                return ModelConfigResponse
            code = schemas.StrSchema
        
            @staticmethod
            def arguments_type() -> typing.Type['EvaluatorArgumentsType']:
                return EvaluatorArgumentsType
        
            @staticmethod
            def return_type() -> typing.Type['EvaluatorReturnTypeEnum']:
                return EvaluatorReturnTypeEnum
            __annotations__ = {
                "id": id,
                "type": type,
                "status": status,
                "name": name,
                "evaluator_type": evaluator_type,
                "description": description,
                "other": other,
                "created_by": created_by,
                "model_config": model_config,
                "code": code,
                "arguments_type": arguments_type,
                "return_type": return_type,
            }
    
    name: MetaOapg.properties.name
    id: MetaOapg.properties.id
    type: MetaOapg.properties.type
    evaluator_type: MetaOapg.properties.evaluator_type
    status: MetaOapg.properties.status
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["status"]) -> MetaOapg.properties.status: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["evaluator_type"]) -> MetaOapg.properties.evaluator_type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["other"]) -> MetaOapg.properties.other: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["created_by"]) -> 'UserResponse': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["model_config"]) -> 'ModelConfigResponse': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["code"]) -> MetaOapg.properties.code: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["arguments_type"]) -> 'EvaluatorArgumentsType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["return_type"]) -> 'EvaluatorReturnTypeEnum': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "type", "status", "name", "evaluator_type", "description", "other", "created_by", "model_config", "code", "arguments_type", "return_type", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["status"]) -> MetaOapg.properties.status: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["evaluator_type"]) -> MetaOapg.properties.evaluator_type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["other"]) -> typing.Union[MetaOapg.properties.other, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["created_by"]) -> typing.Union['UserResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["model_config"]) -> typing.Union['ModelConfigResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["code"]) -> typing.Union[MetaOapg.properties.code, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["arguments_type"]) -> typing.Union['EvaluatorArgumentsType', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["return_type"]) -> typing.Union['EvaluatorReturnTypeEnum', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "type", "status", "name", "evaluator_type", "description", "other", "created_by", "model_config", "code", "arguments_type", "return_type", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        id: typing.Union[MetaOapg.properties.id, str, ],
        type: typing.Union[MetaOapg.properties.type, str, ],
        evaluator_type: typing.Union[MetaOapg.properties.evaluator_type, str, ],
        status: typing.Union[MetaOapg.properties.status, str, ],
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        other: typing.Union[MetaOapg.properties.other, dict, frozendict.frozendict, schemas.Unset] = schemas.unset,
        created_by: typing.Union['UserResponse', schemas.Unset] = schemas.unset,
        model_config: typing.Union['ModelConfigResponse', schemas.Unset] = schemas.unset,
        code: typing.Union[MetaOapg.properties.code, str, schemas.Unset] = schemas.unset,
        arguments_type: typing.Union['EvaluatorArgumentsType', schemas.Unset] = schemas.unset,
        return_type: typing.Union['EvaluatorReturnTypeEnum', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'EvaluatorConfigResponse':
        return super().__new__(
            cls,
            *args,
            name=name,
            id=id,
            type=type,
            evaluator_type=evaluator_type,
            status=status,
            description=description,
            other=other,
            created_by=created_by,
            model_config=model_config,
            code=code,
            arguments_type=arguments_type,
            return_type=return_type,
            _configuration=_configuration,
            **kwargs,
        )

from humanloop.model.evaluator_arguments_type import EvaluatorArgumentsType
from humanloop.model.evaluator_return_type_enum import EvaluatorReturnTypeEnum
from humanloop.model.model_config_response import ModelConfigResponse
from humanloop.model.user_response import UserResponse
