# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from humanloop import schemas  # noqa: F401


class EvaluatorResponse(
    schemas.DictSchema
):
    """
    This class is auto generated by Konfig (https://konfigthis.com)
    """


    class MetaOapg:
        required = {
            "return_type",
            "updated_at",
            "name",
            "created_at",
            "description",
            "arguments_type",
            "id",
            "type",
        }
        
        class properties:
            
            
            class description(
                schemas.StrSchema
            ):
                pass
            
            
            class name(
                schemas.StrSchema
            ):
                pass
        
            @staticmethod
            def arguments_type() -> typing.Type['EvaluatorArgumentsType']:
                return EvaluatorArgumentsType
        
            @staticmethod
            def return_type() -> typing.Type['EvaluatorReturnTypeEnum']:
                return EvaluatorReturnTypeEnum
        
            @staticmethod
            def type() -> typing.Type['EvaluatorType']:
                return EvaluatorType
            id = schemas.StrSchema
            created_at = schemas.DateTimeSchema
            updated_at = schemas.DateTimeSchema
            code = schemas.StrSchema
        
            @staticmethod
            def model_config() -> typing.Type['ModelConfigResponse']:
                return ModelConfigResponse
        
            @staticmethod
            def logging_project() -> typing.Type['ProjectResponse']:
                return ProjectResponse
            __annotations__ = {
                "description": description,
                "name": name,
                "arguments_type": arguments_type,
                "return_type": return_type,
                "type": type,
                "id": id,
                "created_at": created_at,
                "updated_at": updated_at,
                "code": code,
                "model_config": model_config,
                "logging_project": logging_project,
            }
    
    return_type: 'EvaluatorReturnTypeEnum'
    updated_at: MetaOapg.properties.updated_at
    name: MetaOapg.properties.name
    created_at: MetaOapg.properties.created_at
    description: MetaOapg.properties.description
    arguments_type: 'EvaluatorArgumentsType'
    id: MetaOapg.properties.id
    type: 'EvaluatorType'
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["arguments_type"]) -> 'EvaluatorArgumentsType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["return_type"]) -> 'EvaluatorReturnTypeEnum': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> 'EvaluatorType': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["created_at"]) -> MetaOapg.properties.created_at: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["updated_at"]) -> MetaOapg.properties.updated_at: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["code"]) -> MetaOapg.properties.code: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["model_config"]) -> 'ModelConfigResponse': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["logging_project"]) -> 'ProjectResponse': ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["description", "name", "arguments_type", "return_type", "type", "id", "created_at", "updated_at", "code", "model_config", "logging_project", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["name"]) -> MetaOapg.properties.name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["arguments_type"]) -> 'EvaluatorArgumentsType': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["return_type"]) -> 'EvaluatorReturnTypeEnum': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> 'EvaluatorType': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["created_at"]) -> MetaOapg.properties.created_at: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["updated_at"]) -> MetaOapg.properties.updated_at: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["code"]) -> typing.Union[MetaOapg.properties.code, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["model_config"]) -> typing.Union['ModelConfigResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["logging_project"]) -> typing.Union['ProjectResponse', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["description", "name", "arguments_type", "return_type", "type", "id", "created_at", "updated_at", "code", "model_config", "logging_project", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        return_type: 'EvaluatorReturnTypeEnum',
        updated_at: typing.Union[MetaOapg.properties.updated_at, str, datetime, ],
        name: typing.Union[MetaOapg.properties.name, str, ],
        created_at: typing.Union[MetaOapg.properties.created_at, str, datetime, ],
        description: typing.Union[MetaOapg.properties.description, str, ],
        arguments_type: 'EvaluatorArgumentsType',
        id: typing.Union[MetaOapg.properties.id, str, ],
        type: 'EvaluatorType',
        code: typing.Union[MetaOapg.properties.code, str, schemas.Unset] = schemas.unset,
        model_config: typing.Union['ModelConfigResponse', schemas.Unset] = schemas.unset,
        logging_project: typing.Union['ProjectResponse', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'EvaluatorResponse':
        return super().__new__(
            cls,
            *args,
            return_type=return_type,
            updated_at=updated_at,
            name=name,
            created_at=created_at,
            description=description,
            arguments_type=arguments_type,
            id=id,
            type=type,
            code=code,
            model_config=model_config,
            logging_project=logging_project,
            _configuration=_configuration,
            **kwargs,
        )

from humanloop.model.evaluator_arguments_type import EvaluatorArgumentsType
from humanloop.model.evaluator_return_type_enum import EvaluatorReturnTypeEnum
from humanloop.model.evaluator_type import EvaluatorType
from humanloop.model.model_config_response import ModelConfigResponse
from humanloop.model.project_response import ProjectResponse
