# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal, TYPE_CHECKING
from pydantic import BaseModel, Field, RootModel, ConfigDict

from humanloop.pydantic.evaluator_arguments_type import EvaluatorArgumentsType
from humanloop.pydantic.evaluator_return_type_enum import EvaluatorReturnTypeEnum
from humanloop.pydantic.model_config_response import ModelConfigResponse
from humanloop.pydantic.user_response import UserResponse

class EvaluatorConfigResponse(BaseModel):
    # String ID of config. Starts with `config_`.
    id: str = Field(alias='id')

    type: Literal["evaluator"] = Field(alias='type')

    # Whether the config is committed or not.
    status: str = Field(alias='status')

    # Name of config.
    name: str = Field(alias='name')

    # Type of evaluator.
    evaluator_type: str = Field(alias='evaluator_type')

    # Description of config.
    description: typing.Optional[str] = Field(None, alias='description')

    # Other parameters that define the config.
    other: typing.Optional[typing.Dict[str, typing.Union[bool, date, datetime, dict, float, int, list, str, None]]] = Field(None, alias='other')

    # The user who created the config.
    created_by: typing.Optional[UserResponse] = Field(None, alias='created_by')

    # The model config defining the LLM evaluator.
    model_config_: typing.Optional[ModelConfigResponse] = Field(None, alias='model_config')

    # The code for the evaluator. This code will be executed in a sandboxed environment.
    code: typing.Optional[str] = Field(None, alias='code')

    # Whether this evaluator is target-free or target-required.
    arguments_type: typing.Optional[EvaluatorArgumentsType] = Field(None, alias='arguments_type')

    # The type of the return value of the evaluator.
    return_type: typing.Optional[EvaluatorReturnTypeEnum] = Field(None, alias='return_type')

    model_config = ConfigDict(
        protected_namespaces=(),
        arbitrary_types_allowed=True
    )
